<template>
    <div class="q-gutter-y-lg full-width">
        <q-select filled :options="OptionsStart" map-options :value="StartValue" @input='SelectInput("start",$event)' label="When"/>

        <q-input v-if="startCustom" :value="start" @input="Input('start', $event)" label="Custom When" filled type="number">
            <template #append>
                <div class="text-body1">days ago</div>
            </template>
        </q-input>
        <q-select filled :options="OptionsDuration" map-options :value="AmountValue" @input='SelectInput("amount",$event)' label="Time Span"/>

        <q-input v-if="amountCustom" :value="amount" @input="Input('amount', $event)" label="Time Span" filled type="number">
            <template #prepend>
                <div class="text-body1">Last</div>
            </template>
            <template #append>
                <div class="text-body1">days</div>
            </template>
        </q-input>
    </div>
</template>

<script lang='ts'>
import {Component, Prop, Vue, Watch} from 'vue-property-decorator';
import {TimeQuery} from "src/classLibrary/Dashboard/SingeMetricQuery";
import {RelativeTimeConfig} from "src/classLibrary/Dashboard/Dashboard";

@Component
export default class TimeQueryPicker extends Vue {

    @Prop() value!: TimeQuery | RelativeTimeConfig
    @Prop() all!: boolean

    start: number = 0;
    amount: number = 1;

    startCustom: boolean = false;
    amountCustom: boolean = false;

    get AmountValue() {
        if (this.amountCustom) {
            return null;
        } else {
            return this.amount;
        }
    }

    get StartValue() {
        if (this.startCustom) {
            return null;
        } else {
            return this.start;
        }
    }

    SelectInput(key: string, v: { label: string, value: number | null }) {
        const value = v.value;
        if (value == null) {
            if (key == 'start') {
                this.startCustom = true
            } else {
                this.amountCustom = true;
            }
        } else {
            if (key == 'start') {
                this.startCustom = false
            } else {
                this.amountCustom = false;
            }
            this.Input(key, value as number)
        }
    }

    Input(key: string, value: number) {
        let r: RelativeTimeConfig = {
            start: this.start, amount: this.amount,
        };

        (r as any)[key] = value.ToInt();


        if (r.start === -1) {
            this.$emit('input', TimeQuery.All())
        } else {
            if (this.all) {
                this.$emit('input', TimeQuery.Range(r))
            } else {
                this.$emit('input', r);
            }
        }
    }

    @Watch('value', {deep: true})
    OnValueChange() {

        function FormatConfig(p: TimeQueryPicker, v: RelativeTimeConfig) {
            p.start = v.start;
            p.amount = v.amount;
        }

        if ((this.value as RelativeTimeConfig).start) {
            const v = this.value as RelativeTimeConfig;
            FormatConfig(this, v)

        } else {
            const v = this.value as TimeQuery;
            const p = this;
            TimeQuery.match(v, {
                All() {
                    p.start = -1;

                }, Range(c: RelativeTimeConfig) {
                    FormatConfig(p, c);
                }

            })
        }
    }


    get OptionsDuration() {
        return [
            {
                label: 'Past 1 day',
                value: 1,
            },
            {
                label: 'Past 2 days',
                value: 2,
            },
            {
                label: 'Past 4 days',
                value: 4,
            },
            {
                label: 'Past week',
                value: 7,
            },
            {
                label: 'Past 30 days',
                value: 30,
            },
            {
                label: 'Custom',
                value: null,
            },
        ]
    }

    get OptionsStart() {
        const all = {
            label: 'All',
            value: -1,
        }
        const r = [
            {
                label: 'Today',
                value: 0,
            },
            {
                label: 'Yesterday',
                value: 1,
            },
            {
                label: '2 days ago',
                value: 2,
            },
            {
                label: '4 days ago',
                value: 4,
            },
            {
                label: 'A week ago',
                value: 7,
            },
            {
                label: '30 Days ago',
                value: 30,
            },
            {
                label: 'Custom',
                value: null,
            },
        ]
        if (this.all) {
            return [all, ...r]
        }
        return r;
    }
}
</script>

<style lang='scss' scoped>

</style>
